<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: /home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/slot_api.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/slot_api.h</h1><div class="fragment"><pre>00001 <span class="comment">/*</span>
00002 <span class="comment"> * Slot driver API.</span>
00003 <span class="comment"> *</span>
00004 <span class="comment"> * Copyright (C) 2007 Cambridge Silicon Radio Ltd.</span>
00005 <span class="comment"> *</span>
00006 <span class="comment"> * Refer to LICENSE.txt included with this source code for details on</span>
00007 <span class="comment"> * the license terms.</span>
00008 <span class="comment"> */</span>
00009 <span class="preprocessor">#ifndef _SLOT_API_H</span>
00010 <span class="preprocessor"></span><span class="preprocessor">#define _SLOT_API_H</span>
00011 <span class="preprocessor"></span>
00012 <span class="preprocessor">#include &lt;sdioemb/sdio_api.h&gt;</span>
00013 
00029 <span class="preprocessor">#define SDD_BUS_FREQ_OFF      0</span>
00030 <span class="preprocessor"></span><span class="preprocessor">#define SDD_BUS_FREQ_DEFAULT -1</span>
00031 <span class="preprocessor"></span><span class="preprocessor">#define SDD_BUS_FREQ_IDLE    -2</span>
00032 <span class="preprocessor"></span>
<a name="l00038"></a><a class="code" href="group__sdriver.html#ga32">00038</a> <span class="keyword">enum</span> <a class="code" href="group__sdriver.html#ga32">sdio_power</a> {
00039     <a class="code" href="group__sdriver.html#gga32a3">SDIO_POWER_OFF</a>  =   0, 
00040     <a class="code" href="group__sdriver.html#gga32a4">SDIO_POWER_3V3</a>  =  33, 
00041 };
00042 
<a name="l00048"></a><a class="code" href="structslot__caps.html">00048</a> <span class="keyword">struct </span><a class="code" href="structslot__caps.html">slot_caps</a> {
<a name="l00049"></a><a class="code" href="structslot__caps.html#o0">00049</a>     <span class="keywordtype">int</span> <a class="code" href="structslot__caps.html#o0">max_bus_freq</a>;  
<a name="l00050"></a><a class="code" href="structslot__caps.html#o1">00050</a>     <span class="keywordtype">int</span> <a class="code" href="structslot__caps.html#o1">max_bus_width</a>; 
<a name="l00051"></a><a class="code" href="structslot__caps.html#o2">00051</a>     uint8_t <a class="code" href="structslot__caps.html#o2">cspi_mode</a>; 
00052 };
00053 
00057 <span class="keyword">enum</span> slot_controller_type {
00058     SDD_SLOT_TYPE_SD = 0,   
00059     SDD_SLOT_TYPE_SPI,      
00060     SDD_SLOT_TYPE_SPI_CSPI, 
00061 };
00062 
00063 <span class="keyword">struct </span>sdio_slot_priv;
00064 
<a name="l00072"></a><a class="code" href="structsdio__slot.html">00072</a> <span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> {
<a name="l00079"></a><a class="code" href="structsdio__slot.html#o0">00079</a>     <span class="keywordtype">char</span> <a class="code" href="structsdio__slot.html#o0">name</a>[64];
00080 
<a name="l00084"></a><a class="code" href="structsdio__slot.html#o1">00084</a>     <span class="keyword">enum</span> slot_controller_type <a class="code" href="structsdio__slot.html#o1">type</a>;
00085 
00114     int (*set_bus_freq)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> clk);
00115 
00133     int (*set_bus_width)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> <a class="code" href="structsdio__slot.html#o12">bus_width</a>);
00134 
00148     int (*start_cmd)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">struct </span><a class="code" href="structsdio__cmd.html">sdio_cmd</a> *cmd);
00149 
00159     int (*card_present)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00160 
00172     int (*card_power)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">enum</span> <a class="code" href="group__sdriver.html#ga32">sdio_power</a> power);
00173 
00181     void (*enable_card_int)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00182 
00190     void (*disable_card_int)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00191 
00208     int (*hard_reset)(<span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00209 
<a name="l00210"></a><a class="code" href="structsdio__slot.html#o10">00210</a>     <span class="keyword">struct </span><a class="code" href="structslot__caps.html">slot_caps</a>         caps;           
<a name="l00211"></a><a class="code" href="structsdio__slot.html#o11">00211</a>     <span class="keywordtype">int</span>                      <a class="code" href="structsdio__slot.html#o11">clock_freq</a>;     
<a name="l00212"></a><a class="code" href="structsdio__slot.html#o12">00212</a>     <span class="keywordtype">int</span>                      <a class="code" href="structsdio__slot.html#o12">bus_width</a>;      
<a name="l00213"></a><a class="code" href="structsdio__slot.html#o13">00213</a>     <span class="keywordtype">int</span>                      <a class="code" href="structsdio__slot.html#o13">cspi_reg_pad</a>;   
<a name="l00214"></a><a class="code" href="structsdio__slot.html#o14">00214</a>     <span class="keywordtype">int</span>                      <a class="code" href="structsdio__slot.html#o14">cspi_burst_pad</a>; 
<a name="l00215"></a><a class="code" href="structsdio__slot.html#o15">00215</a>     <span class="keyword">struct </span>sdio_slot_priv *<a class="code" href="structsdio__slot.html#o15">priv</a>;           
<a name="l00216"></a><a class="code" href="structsdio__slot.html#o16">00216</a>     <span class="keywordtype">void</span> *                   <a class="code" href="structsdio__slot.html#o16">drv_data</a>;       
00217 };
00218 
00219 <span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *<a class="code" href="group__sdriver.html#ga6">sdio_slot_alloc</a>(size_t drv_data_size);
00220 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga7">sdio_slot_free</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00221 <span class="keywordtype">int</span> <a class="code" href="group__sdriver.html#ga8">sdio_slot_register</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00222 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga9">sdio_slot_unregister</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00223 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga0">sdio_card_inserted</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00224 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga1">sdio_card_removed</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00225 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga3">sdio_interrupt</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00226 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga2">sdio_cmd_complete</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">struct</span> <a class="code" href="structsdio__cmd.html">sdio_cmd</a> *cmd);
00227 
00228 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga4">sdio_suspend</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00229 <span class="keywordtype">void</span> <a class="code" href="group__sdriver.html#ga5">sdio_resume</a>(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00230 
00231 
00232 <span class="preprocessor">#endif </span><span class="comment">/* #ifndef _SLOT_API_H */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
